/*------------------------------------------------------------------
 * Compile:
gcc -c tris_thread_4_4.c
gcc -o tris_thread_4_4 tris_thread_4_4.c -lm -lws2_32 -lgdi32
gcc -c tris_thread_4_4.c
gcc -o tris_thread_4_4 tris_thread_4_4.c -lm -lws2_32 -lgdi32
gcc -c tris_thread_4_4.c
gcc -o tris_thread_4_4 tris_thread_4_4.c -lm -lws2_32 -lgdi32
------------------------------------------------------------------*/
#include <stdio.h>
#include <Windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <Windows.h>

//definition
#define D_RIGHT 1000
#define D_LEFT 1001
#define D_DOWN 1002
#define MAPY 22
#define MAPX 30
#define ARR 4
#define SUCC 1
#define FAIL 0
#define MAXDESIGN 12

#define RIGHT_KEY 77
#define LEFT_KEY 75
#define DOWN_KEY 80
#define ENTER_KEY 13
#define SPACE_KEY 32
#define ESC_KEY 27

#define TIME_TICK_INTERVAL 600

//variables
int tris[MAPY][MAPX];
int tris_bak[MAPY][MAPX];
int design[ARR][ARR];
int realdesign[MAXDESIGN][ARR][ARR]=
{
{{0,1,0,0},{0,1,0,0},{0,1,0,0},{0,1,0,0}},
{{0,0,0,0},{0,1,1,0},{0,1,1,0},{0,0,0,0}},
{{0,0,0,0},{0,1,0,0},{1,1,1,0},{0,0,0,0}},
{{0,0,1,0},{0,1,1,0},{0,1,0,0},{0,0,0,0}},
{{0,1,0,0},{0,1,1,0},{0,0,1,0},{0,0,0,0}},
{{0,0,0,0},{0,1,0,0},{0,1,1,1},{0,0,0,0}},

{{0,1,0,0},{0,1,0,0},{0,1,0,0},{0,1,0,0}},
{{0,0,0,0},{0,1,1,0},{0,1,1,0},{0,0,0,0}},
{{0,0,0,0},{0,1,0,0},{1,1,1,0},{0,0,0,0}},
{{0,0,1,0},{0,1,1,0},{0,1,0,0},{0,0,0,0}},
{{0,1,0,0},{0,1,1,0},{0,0,1,0},{0,0,0,0}},
{{0,0,0,0},{0,1,0,0},{0,1,1,1},{0,0,0,0}},
};
int xpos,ypos,score;
int hyun,next;
int oneclick;

//prototypes
void stop();
void ____init(int);
void init();
int common_check(int);
int direct_check();
void draw();
void delete_column(int,int);
int check_horizon();
int exchange_check();
void tris_time_tick_detail(void);

void tris_time_tick_detail(void)
{
	int rc;

	draw();

	rc=common_check(D_DOWN);
	if(rc==FAIL)
	{
		if(ypos==0)
		{
			//TERMINATION
			//TERMINATION
			exit(0);
		}
		else
		{
			while(1)
			{
				if(check_horizon()==FAIL) break;
			}

			____init(FAIL);
		}
	}
}


//TIME EVENT BY TIME_TICK_INTERVAL
//TIME EVENT BY TIME_TICK_INTERVAL
//TIME EVENT BY TIME_TICK_INTERVAL
//TIME EVENT BY TIME_TICK_INTERVAL
unsigned _stdcall tris_time_tick(void* arg)
{
	int rc, ii, kk;

    while(1)
    {
		tris_time_tick_detail();
        Sleep(TIME_TICK_INTERVAL);
	}
	return(SUCC);
}

int common_check(int direction)
{
	int ii,kk,ff;
    int tristmp[MAPY][MAPX];

	for(ii=0; ii<MAPY; ii++)
	{
		for(kk=0; kk<MAPX; kk++)
	    { 
			tristmp[ii][kk]=tris[ii][kk];
		}
	}

	for(ii=0; ii<ARR; ii++)
	{
		for(kk=0; kk<ARR; kk++)
		{
			if(ypos+ii > MAPY-1) continue;
			if(xpos+kk>MAPX-1) continue;
			if(xpos+kk<0) continue;

			if(design[ii][kk]==1) tristmp[ypos+ii][xpos+kk]=0;
		}
	}

	if(direction == D_RIGHT) xpos++;
	if(direction == D_LEFT) xpos--;
	if(direction == D_DOWN) ypos++;

	for(ii=0; ii<ARR; ii++)
	{
		for(kk=0; kk<ARR; kk++)
		{
			if(ypos+ii > MAPY-1) continue;
			if(xpos+kk>MAPX-1) continue;
			if(xpos+kk<0) continue;

			if(design[ii][kk]==1) tristmp[ypos+ii][xpos+kk] += 1;
		}
	}

	ff=0;
	for(ii=0; ii<ARR; ii++)
	{
		for(kk=0; kk<ARR; kk++)
		{
			if(ypos+ii > MAPY-1) continue;
			if(xpos+kk>MAPX-1) continue;
			if(xpos+kk<0) continue;

			if(tristmp[ypos+ii][xpos+kk] > 1) ff++;
		}
	}

	if(ff>0)
	{
		if(direction == D_RIGHT) xpos--;
		if(direction == D_LEFT) xpos++;
		if(direction == D_DOWN) ypos--;

		return(FAIL);
	}
	else
	{
		for(ii=0; ii<MAPY; ii++)
	    {
		    for(kk=0; kk<MAPX; kk++)
	        { 
			    tris[ii][kk]=tristmp[ii][kk];
			}
		}
	}
	return(SUCC);
}

void ____init(int direction)
{
	int ii,kk;

	if(direction==SUCC)
	{
		score=0;
		xpos=MAPX/2;
        ypos=0;

		hyun=rand() % MAXDESIGN;
		next=rand() % MAXDESIGN;

		for(ii=0; ii<ARR; ii++)
   		{
    		for(kk=0; kk<ARR; kk++)
	    	{
		    	design[ii][kk] = realdesign[hyun][ii][kk];
				tris[ypos+ii][xpos+kk] = design[ii][kk];
   			}
		}
	}
	else if(direction==FAIL)
	{
		xpos=MAPX/2;
        ypos=0;

		hyun=next;
		next=rand() % MAXDESIGN;

		for(ii=0; ii<ARR; ii++)
   		{
    		for(kk=0; kk<ARR; kk++)
	    	{
		    	design[ii][kk] = realdesign[hyun][ii][kk];
				tris[ypos+ii][xpos+kk] = design[ii][kk];
   			}
		}
	}
}

void init()
{
	int ii,kk;

	oneclick=0;

	_beginthreadex(NULL, 0, tris_time_tick, 0, 0, NULL);

	//
	for(ii=0; ii<MAPY; ii++)
	{
		for(kk=0; kk<MAPX; kk++)
		{
			tris[ii][kk]=0;
		}
	}
	for(ii=0; ii<MAPY; ii++)
	{
		tris[ii][0]=1;
		tris[ii][MAPX-1]=1;
	}
	for(kk=0; kk<MAPX; kk++)
	{
		tris[MAPY-1][kk]=1;
	}

    ____init(SUCC);
}

void stop()
{
	//
}

void gotoxy(int x, int y)
{
    COORD Pos = {x - 1, y - 1};
    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), Pos);
}

void draw()
{
	int ii,kk;

    if(oneclick==0)
	{
		for(ii=0; ii<MAPY; ii++)
		{
			for(kk=0; kk<MAPX; kk++)
			{
				if(tris[ii][kk] == 0)
				{
					gotoxy(kk * 2 + 1, ii + 2);
					printf("");

				}
				else
				{
				   gotoxy(kk * 2 + 1, ii + 2);
				   printf("");
				}
			}
		}
		gotoxy(1, ii + 2);
		printf("Now Score:[%10d]", score);

		oneclick=100;
	}
	else
	{
		for(ii=0; ii<MAPY; ii++)
		{
			for(kk=0; kk<MAPX; kk++)
			{
				if(tris_bak[ii][kk]==tris[ii][kk]) continue;

				if(tris[ii][kk] == 0)
				{
					gotoxy(kk * 2 + 1, ii + 2);
					printf("");

				}
				else
				{
				   gotoxy(kk * 2 + 1, ii + 2);
				   printf("");
				}
			}
		}
		gotoxy(1, ii + 2);
		printf("Now Score:[%10d]", score);
	}

	for(ii=0; ii<MAPY; ii++)
    {
        for(kk=0; kk<MAPX; kk++)
        {
			tris_bak[ii][kk] = tris[ii][kk];
		}
	}
}

int direct_check()
{
	int ii,kk,rc;

	while(1)
	{
		rc=common_check(D_DOWN);
		if(rc==FAIL) break;

		draw();
	}

	while(1)
	{
		if(check_horizon()==FAIL) break;
	}

    ____init(FAIL);
}

void delete_column(int y,int x)
{
	int ii;

	for(ii=y; ii>=1; ii--)
	{
		tris[ii][x]=tris[ii-1][x];
	}
}

int check_horizon()
{
	int ii,kk,ff;

	for(ii=0; ii<MAPY-1; ii++)
	{
		ff=0;
		for(kk=1; kk<MAPX-2; kk++)
		{
			if(tris[ii][kk] != 0)
			{
				if(tris[ii][kk] == tris[ii][kk+1]) ff++;
				else break;
			}
		}

		if(ff==MAPX-3)
		{
			for(kk=1; kk<MAPX-1; kk++)
			{
				delete_column(ii,kk);
			}
			score++;

			return(SUCC);
		}
	}
	return(FAIL);
}

int exchange_check()
{
	int tmp;
	int ii,kk,hh;
	int tristmp[MAPY][ MAPX];
	int destmp[ARR][ARR];

	for(ii=0; ii<ARR; ii++)
	{
		for(kk=0; kk<ARR; kk++)
		{
			destmp[ii][kk] = design[ii][kk];
		}
	}

	for(ii=0; ii<MAPY; ii++)
	{
		for(kk=0; kk<MAPX; kk++)
		{
			tristmp[ii][kk] = tris[ii][kk];
		}
	}

	for(ii=0; ii<ARR; ii++)
	{
		for(kk=0; kk<ARR; kk++)
		{
			if(destmp[ii][kk]==1)
			{
				if(xpos+kk>MAPX-1) continue;
			    if(xpos+kk<0) continue;

				tristmp[ypos + 0 + ii][ xpos + kk] = 0;
			}
		}
	}

	for(ii=0; ii<3; ii++)
	{
		tmp       = destmp[0][0];
		destmp[0][0] = destmp[0][1];
		destmp[0][1] = destmp[0][2];
		destmp[0][2] = destmp[0][3];
		destmp[0][3] = destmp[1][3];				
		destmp[1][3] = destmp[2][3];
		destmp[2][3] = destmp[3][3];
		destmp[3][3] = destmp[3][2];
		destmp[3][2] = destmp[3][1];
		destmp[3][1] = destmp[3][0];
		destmp[3][0] = destmp[2][0];
		destmp[2][0] = destmp[1][0];
		destmp[1][0] = tmp;
	}
	tmp=destmp[1][1];
	destmp[1][1] = destmp[1][2];
	destmp[1][2] = destmp[2][2];
	destmp[2][2] = destmp[2][1];
	destmp[2][1]=tmp;

	for(ii=0; ii<ARR; ii++)
	{
		for(kk=0; kk<ARR; kk++)
		{
			if(destmp[ii][kk]==1)
			{
				if(xpos+kk>MAPX-1) continue;
			    if(xpos+kk<0) continue;

				tristmp[ypos + 0 + ii][ xpos + kk] = tristmp[ypos + 0 + ii][ xpos + kk] + destmp[ii][kk];
			}
		}
	}

	hh=0;
	for(ii=0; ii<ARR; ii++)
	{
		for(kk=0; kk<ARR; kk++)
		{
			if(destmp[ii][kk]==1)
			{
				if(xpos+kk>MAPX-1) continue;
			    if(xpos+kk<0) continue;

				if(tristmp[ypos + 0 + ii][ xpos + kk]>1) hh++;
			}
		}
	}

	if(hh>0) 
	{
	    return FAIL;
	}
	else
	{
		for(ii=0; ii<MAPY; ii++)
		{
			for(kk=0; kk<MAPX; kk++)
			{
				tris[ii][kk] = tristmp[ii][kk];
			}  
		}

		//DESIGN
		for(ii=0; ii<ARR; ii++)
		{
			for(kk=0; kk<ARR; kk++)
			{
				design[ii][kk] = destmp[ii][kk];
			}
		}
	}
	return(SUCC);
}

void main(void)
{
	int ch, rc;

	init();

    while(1)
    {
		/*KEY-----------------------------------------------------------------------*/
        if(kbhit())
        {
            ch = getch();
            if(ch == 224)
            {
                ch = getch();
                if(ch == RIGHT_KEY)
                {
                    rc = common_check(D_RIGHT);
                }
                else if(ch == LEFT_KEY)
                {
                    rc = common_check(D_LEFT);
                }
                else if(ch == DOWN_KEY)
                {
                    rc = common_check(D_DOWN);
                }
            }
            else if(ch == ENTER_KEY)
            {
				rc = direct_check();
            }
            else if(ch == SPACE_KEY)
            {
                rc = exchange_check();
            }
            else if(ch == ESC_KEY)
            {
                break;
            }

			draw();
        }
		/*NO KEY--------------------------------------------------------------------*/
     }//END WHILE

	 stop();
}


